%% OBTAIN R from F with aditional constraints. 
get_c; 
get_prop; 
get_spline;

n=3;
w=2*pi/T;
coeficients=n*((n+1)/2)*(2*M_mat+1);

At=zeros((3*n+1)*L*(3*n+1)*L,coeficients);
F=zeros((3*n+1)*L,(3*n+1)*L*coeficients); 
F_0=zeros((3*n+1)*L,(3*n+1)*L); 
b_w=zeros(3,L);
for j=0:(L-1)
     
tj=(j)*T/L;

varphi=varphi_nom(j+1);
d_varphi=d_varphi_nom(j+1);
p_sol=d_varphi_nom(j+1);
get_par; 
theta = Theta; 
d_theta = d_Theta*d_varphi;
Pi = [cos(theta) -sin(theta) 0; sin(theta) cos(theta) 0; 0 0 1]; 
d_Pi = [-sin(theta) -cos(theta) 0; cos(theta) -sin(theta) 0; 0 0 0];

 m11 = prop.m_b*norm(rho)^2 + prop.J_f + prop.J_b; 
 m12 = (dot(prop.m_b*prop.k_hat ,cross(rho,tau)) + prop.J_b*p)*d_s; 
 m21 = m12; 
 m22 = (prop.m_b + prop.J_b*p^2)*d_s^2; 
 M = [m11 m12; m21 m22];
   
 c11 = dot(prop.m_b*d_s*rho,tau*d_varphi); 
 c12 = dot(prop.m_b*d_s*rho,tau*d_theta)+d_varphi*((dot(prop.m_b*prop.k_hat ,cross(rho,tau))+prop.J_b*p)*dd_s + dot(prop.m_b*prop.k_hat ,cross(rho,kappa))*d_s^2); 
 c21 = -dot(prop.m_b*d_s*rho,tau*d_theta); 
 c22 = (prop.m_b+prop.J_b*p^2)*d_s*dd_s*d_varphi; 
 C = [c11 c12; c21 c22];
    
 g1 = dot(prop.m_b*prop.grav ,d_Pi*rho); 
 g2 = dot(prop.m_b*prop.grav ,Pi*tau*d_s); 
 G = [g1;g2];

Alpha = m21*d_Theta + m22; 
Beta1 = m21*dd_Theta; 
Beta2 = c21*d_Theta + c22; 
Gamma = g2;
%% New Matrices 
L=[1, d_Theta; 0, 1];
N=[dd_Theta*p_sol^2; 0]; 

%% Calculation of gy gd_y and gw 
gw = -m12;
gdy = dot(prop.m_b*d_s*rho,(tau.')*(d_y+2*d_Theta*p_sol)); 
gy= dot(-d_s*prop.m_b*9.81*[cos(y/2+Theta), sin(y/2+Theta),0],tau*(sin(y/2)/(y/2)));

%% Calculation of A and b. 
Beta =  m21*dd_Theta-dot(prop.m_b*d_s*rho,tau)*d_Theta^2+(prop.m_b+prop.J_b*p^2)*d_s*dd_s;
A=[0, 1, 0; 0, 0, 0; gy/Alpha, gdy/Alpha, (Gamma-Beta*p_sol^2)/(Alpha*p_sol)];
b=[0; 1; gw/Alpha];
b_w(1:3,j)=b;
%% Calculate solution to Ricatti diferential equation. 
A_T=A.';
B=b;
B_T=b.';
Q=eye(n);
Ghe=1;

%% Construction of F0 
F_01=zeros(n,1);
F_02=zeros(1,n);
F_03=[Q F_01;F_02 Ghe];
F_04=[d*ones(n) zeros(n,n); zeros(n,n) d*ones(n)];
F_05=[F_03 zeros(n+1,2*n);zeros(2*n,n+1) F_04];
F_0((3*n+1)*j+1:(3*n+1)*j+(3*n+1),(3*n+1)*j+1:(3*n+1)*j+(3*n+1))=F_05;

%% Construction of F 
    F_Y_aux1=zeros((n+1),(n+1));
    F_Y_aux2=zeros((2*n),(2*n));
    F_Y_aux=zeros((3*n+1),(3*n+1));
    F_Y=zeros((3*n+1)*L,(3*n+1)*L);
    
    for i=1:6
        if i==1
        Y_Y=[1 0 0;0 0 0;0 0 0]; 
        elseif i==2
        Y_Y=[0 1 0;1 0 0;0 0 0]; 
        elseif i==3
        Y_Y=[0 0 1;0 0 0;1 0 0];
        elseif i==4
        Y_Y=[0 0 0;0 1 0;0 0 0]; 
        elseif i==5
        Y_Y=[0 0 0;0 0 1;0 1 0];
        elseif i==6
        Y_Y=[0 0 0;0 0 0;0 0 1]; 
        end
        F_Y_aux1=[A_T*Y_Y+Y_Y*A Y_Y*B; B_T*Y_Y 0]; 
        F_Y_aux2=[Y_Y zeros(n,n); zeros(n,n) -Y_Y];
        F_Y_aux=[F_Y_aux1 zeros(n+1,2*n);zeros(2*n,n+1) F_Y_aux2];
        F_Y((3*n+1)*j+1:(3*n+1)*j+(3*n+1),(3*n+1)*j+1:(3*n+1)*j+(3*n+1))= F_Y_aux; 
        F(1:(3*n+1)*L,(3*n+1)*L*(i-1)+1:(3*n+1)*L*(i-1)+(3*n+1)*L)=F(1:(3*n+1)*L,(3*n+1)*L*(i-1)+1:(3*n+1)*L*(i-1)+(3*n+1)*L)+F_Y;
        F_Y=zeros((3*n+1)*L,(3*n+1)*L); 
    end 
    for k=0:(M_mat-1)
        F_Y=zeros((3*n+1)*L,(3*n+1)*L);
    for i=7:18
        if i==7   
        Y_Y=[cos((k+1)*w*(tj)) 0 0;0 0 0; 0 0 0]; 
        D_Y=[-(k+1)*w*sin((k+1)*w*(tj)) 0 0;0 0 0; 0 0 0]; 
        elseif i==8
        Y_Y=[0 cos((k+1)*w*(tj)) 0;cos((k+1)*w*(tj)) 0 0; 0 0 0];
        D_Y=[0 -(k+1)*w*sin((k+1)*w*(tj)) 0;-(k+1)*w*sin((k+1)*w*(tj)) 0 0; 0 0 0]; 
        elseif i==9
        Y_Y=[0 0 cos((k+1)*w*(tj));0 0 0; cos((k+1)*w*(tj)) 0 0];
        D_Y=[0 0 -(k+1)*w*sin((k+1)*w*(tj));0 0 0; -(k+1)*w*sin((k+1)*w*(tj)) 0 0]; 
        elseif i==10
        Y_Y=[0 0 0;0 cos((k+1)*w*(tj)) 0; 0 0 0];
        D_Y=[0 0 0;0 -(k+1)*w*sin((k+1)*w*(tj)) 0; 0 0 0]; 
        elseif i==11
        Y_Y=[0 0 0;0 0 cos((k+1)*w*(tj)); 0 cos((k+1)*w*(tj)) 0];
        D_Y=[0 0 0;0 0 -(k+1)*w*sin((k+1)*w*(tj)); 0 -(k+1)*w*sin((k+1)*w*(tj)) 0]; 
        elseif i==12
        Y_Y=[0 0 0;0 0 0; 0 0 cos((k+1)*w*(tj))];
        D_Y=[0 0 0;0 0 0; 0 0 -(k+1)*w*sin((k+1)*w*(tj))]; 
        elseif i==13
        Y_Y=[sin((k+1)*w*(tj)) 0 0;0 0 0; 0 0 0]; 
        D_Y=[(k+1)*w*cos((k+1)*w*(tj)) 0 0;0 0 0; 0 0 0]; 
        elseif i==14
        Y_Y=[0 sin((k+1)*w*(tj)) 0;sin((k+1)*w*(tj)) 0 0; 0 0 0]; 
        D_Y=[0 (k+1)*w*cos((k+1)*w*(tj)) 0;(k+1)*w*cos((k+1)*w*(tj)) 0 0; 0 0 0]; 
        elseif i==15
        Y_Y=[0 0 sin((k+1)*w*(tj));0 0 0; sin((k+1)*w*(tj)) 0 0];
        D_Y=[0 0 (k+1)*w*cos((k+1)*w*(tj));0 0 0; (k+1)*w*cos((k+1)*w*(tj)) 0 0]; 
        elseif i==16
        Y_Y=[0 0 0;0 sin((k+1)*w*(tj)) 0; 0 0 0];
         D_Y=[0 0 0;0 (k+1)*w*cos((k+1)*w*(tj)) 0; 0 0 0]; 
        elseif i==17
        Y_Y=[0 0 0;0 0 sin((k+1)*w*(tj)); 0 sin((k+1)*w*(tj)) 0];
        D_Y=[0 0 0;0 0 (k+1)*w*cos((k+1)*w*(tj)); 0 (k+1)*w*cos((k+1)*w*(tj)) 0];
        elseif i==18
        Y_Y=[0 0 0;0 0 0; 0 0 sin((k+1)*w*(tj))];
        D_Y=[0 0 0;0 0 0; 0 0 (k+1)*w*cos((k+1)*w*(tj))]; 
         
         end
   
        F_Y_aux1=[D_Y+A_T*Y_Y+Y_Y*A Y_Y*B; B_T*Y_Y 0]; 
        F_Y_aux2=[Y_Y zeros(n,n); zeros(n,n) -Y_Y];
        F_Y_aux=[F_Y_aux1 zeros(n+1,2*n);zeros(2*n,n+1) F_Y_aux2];
        F_Y((3*n+1)*j+1:(3*n+1)*j+(3*n+1),(3*n+1)*j+1:(3*n+1)*j+(3*n+1))=F_Y_aux;         
        F(1:(3*n+1)*L,(3*n+1)*L*(i-1)+12*(3*n+1)*L*k+1:(3*n+1)*L*(i-1)+12*(3*n+1)*L*k+(3*n+1)*L)=F(1:(3*n+1)*L,(3*n+1)*L*(i-1)+12*(3*n+1)*L*k+1:(3*n+1)*L*(i-1)+12*(3*n+1)*L*k+(3*n+1)*L)+F_Y;
        F_Y=zeros((3*n+1)*L,(3*n+1)*L);
    end 
    
    end
    
end

p=length(c);
bt=-c;
ct=vec(F_0);
for o=1:p
    At(:,o)=-vec(F(1:(3*n+1)*L,(3*n+1)*L*(o-1)+1:(3*n+1)*L*(o-1)+(3*n+1)*L));
end

K.s=size(F_0,1);
[x,y,info]=sedumi(At,bt,ct,K); 
info;

%% Construction of R_sol of PRDE
dat=y; 
F_11=zeros(1,L);
F_12=zeros(1,L);
F_13=zeros(1,L);
F_22=zeros(1,L);
F_23=zeros(1,L);
F_33=zeros(1,L);

F_Y=zeros(3,3);
F_Y_aux1=zeros(3,3);
F_Y_aux=zeros(3,3);

for j=1:L 
 
    tj=(j-1)*T/L;
    for i=1:6 
        if i==1
        Y_Y=[1 0 0;0 0 0;0 0 0]; 
        elseif i==2
        Y_Y=[0 1 0;1 0 0;0 0 0]; 
        elseif i==3
        Y_Y=[0 0 1;0 0 0;1 0 0];
        elseif i==4
        Y_Y=[0 0 0;0 1 0;0 0 0]; 
        elseif i==5
        Y_Y=[0 0 0;0 0 1;0 1 0];
        elseif i==6
        Y_Y=[0 0 0;0 0 0;0 0 1]; 
        end
        dat_aux=dat(i,1); 
        
        F_Y_aux=dat_aux*Y_Y;
        F_Y=F_Y+F_Y_aux; 
        
    end 
    for k=0:(M_mat-1)
         F_Y_aux=0;
    for i=7:18
        
        if i==7   
        Y_Y=[cos((k+1)*w*(tj)) 0 0;0 0 0; 0 0 0];  
        elseif i==8
        Y_Y=[0 cos((k+1)*w*(tj)) 0;cos((k+1)*w*(tj)) 0 0; 0 0 0];
        elseif i==9
        Y_Y=[0 0 cos((k+1)*w*(tj));0 0 0; cos((k+1)*w*(tj)) 0 0];
        elseif i==10
        Y_Y=[0 0 0;0 cos((k+1)*w*(tj)) 0; 0 0 0];
        elseif i==11
        Y_Y=[0 0 0;0 0 cos((k+1)*w*(tj)); 0 cos((k+1)*w*(tj)) 0]; 
        elseif i==12
        Y_Y=[0 0 0;0 0 0; 0 0 cos((k+1)*w*(tj))];
        elseif i==13
        Y_Y=[sin((k+1)*w*(tj)) 0 0;0 0 0; 0 0 0]; 
        elseif i==14
        Y_Y=[0 sin((k+1)*w*(tj)) 0;sin((k+1)*w*(tj)) 0 0; 0 0 0];  
        elseif i==15
        Y_Y=[0 0 sin((k+1)*w*(tj));0 0 0; sin((k+1)*w*(tj)) 0 0];
        elseif i==16
        Y_Y=[0 0 0;0 sin((k+1)*w*(tj)) 0; 0 0 0]; 
        elseif i==17
        Y_Y=[0 0 0;0 0 sin((k+1)*w*(tj)); 0 sin((k+1)*w*(tj)) 0];
        elseif i==18
        Y_Y=[0 0 0;0 0 0; 0 0 sin((k+1)*w*(tj))];
        end
        dat_aux=dat((n+1)*n*k+i,1); 
        
        F_Y_aux1=dat_aux*Y_Y;
        F_Y_aux=F_Y_aux+F_Y_aux1;
        F_Y_aux1=0;
   
    end 
   
    F_Y=F_Y+F_Y_aux;
    
    end
    F_11(1,j)=F_Y(1,1);
    F_12(1,j)=F_Y(1,2);
    F_13(1,j)=F_Y(1,3);
    F_22(1,j)=F_Y(2,2);
    F_23(1,j)=F_Y(2,3);
    F_33(1,j)=F_Y(3,3);
   
    F_Y=0;
end


