function [u, Fn, Fs] = get_u_Fn_Fs(x,prop) 
varphi = x(1); 
varphi= mod(varphi,2*pi);
d_varphi = x(2);

get_par

theta = Theta; 
d_theta = d_Theta*d_varphi;

Pi = [cos(theta) -sin(theta) 0; sin(theta) cos(theta) 0; 0 0 1]; 
d_Pi = [-sin(theta) -cos(theta) 0; cos(theta) -sin(theta) 0; 0 0 1];

%% Get MCG
m11 = prop.m_b*norm(rho)^2 + prop.J_f + prop.J_b; 
m12 = (dot(prop.m_b*prop.k_hat ,cross(rho,tau)) + prop.J_b*p)*d_s; 
m21 = m12; 
m22 = (prop.m_b + prop.J_b*p^2)*d_s^2; 
M = [m11 m12; m21 m22];
    
c11 = dot(prop.m_b*d_s*rho,tau*d_varphi); 
c12 = dot(prop.m_b*d_s*rho,tau*d_theta)+d_varphi*((dot(prop.m_b*prop.k_hat ,cross(rho,tau))+prop.J_b*p)*dd_s + dot(prop.m_b*prop.k_hat ,cross(rho,kappa))*d_s^2); 
c21 = -dot(prop.m_b*d_s*rho,tau*d_theta); 
c22 = (prop.m_b+prop.J_b*p^2)*d_s*dd_s*d_varphi; 
C = [c11 c12; c21 c22];
    
g1 = dot(prop.m_b*prop.grav ,d_Pi*rho); 
g2 = dot(prop.m_b*prop.grav ,Pi*tau*d_s); 
G = [g1;g2];

%% Get Alpha , Beta , Gamma 
Alpha = m21*d_Theta + m22; 
Beta1 = m21*dd_Theta; 
Beta2 = c21*d_Theta + c22;
Gamma = g2;

dd_varphi = -(Beta1*d_varphi^2 + Beta2*d_varphi + Gamma)/Alpha; 
dd_theta = dd_Theta*d_varphi^2 + d_Theta*dd_varphi;

%% get u and Fn and Fs
u = [m11 m12]*[dd_theta; dd_varphi] + [c11 c12]*[d_theta;d_varphi] + g1;
Fn = dot(prop.m_b*prop.k_hat ,cross(rho,n))*dd_theta + 0.5*dot(prop.m_b*rho,n)*d_theta^2 + 2*prop.m_b*d_s*d_theta*d_varphi+dot(prop.m_b*prop.grav ,Pi*n); 
Fs = -(prop.J_b/prop.R)*(p*dd_s*d_varphi^2 + p*d_s*dd_varphi+dd_theta); 
end
