%% Initialize 
%%It downloads the properties and the program spline to get 
%%
get_prop; 
get_spline;
% sim 
options = odeset('RelTol',1e-5,'AbsTol',1e-6); 
t0 = 0; tend = 3.19; Nsim = 100; 
tspan = linspace(t0,tend ,Nsim); 
x0 = [0;-4.3];

%% Simulation 
prop.pick_MCG = 2; %case decider variable 
[t,x] = ode23(@(t,y)sim_dynamics(t,y,prop),tspan ,x0,options);
%% te ha hecho todo para esas condiciones iniciales, ha integrado y obtenido 
%% varphi y d_varphi
Nres1 =100;
%Nres1=find(x(:,1) >2*pi, 1); %run till 2*pi only
%%Ahora te lee hasta que iteracin, que ha resultado ser la 319
varphi_nom = x(1:Nres1 ,1); d_varphi_nom = x(1:Nres1 ,2); 
%% guarda valores de varphi y d:varphi hasta 2*pi de vharphi. 
u_nom=zeros(1,Nres1); Fn_nom=zeros(1,Nres1); Fs_nom=zeros(1,Nres1); %Crea 3 matrices fila de 0's
for i=1:Nres1 
    [u_nom(i),Fn_nom(i), Fs_nom(i)] = get_u_forces([varphi_nom(i); d_varphi_nom(i)],prop); %%en prop estn todas las propiedades de get:prop
end
mu = 1/min(abs(Fn_nom./Fs_nom)); 

subplot (2,2,1), plot(x(1:100,1),x(1:100,2))
xlabel('') 
ylabel(''), 
subplot (2,2,2), plot(t,x)
xlabel('t [s]')
legend({'[rad]',' [rad/s]'},'orientation','horizontal'), 
subplot(2,2,3),plot(t(1:Nres1),u_nom)
xlabel('t [s]') 
ylabel('Input u [Nm]'); 
subplot(2,2,4),plot(t(1:Nres1),Fn_nom)
hold on 
plot(t(1:Nres1),Fs_nom)
hold off
xlabel('t [s]') 
legend({'Fn[N]','Fs[N]'},'orientation','horizontal');


