if prop.pick_MCG == 1 %Dynamics as from [Lund], other no-slip -condition 
    m11 = prop.m_b*norm(rho)^2 + prop.J_f + prop.J_b; 
    m12 = (dot(prop.m_b*prop.k_hat ,cross(rho,tau)) - prop.J_b/prop.R)*d_s;
    m21 = m12; 
    m22 = (prop.m_b + prop.J_b/prop.R^2)*d_s^2; 
    M = [m11 m12; m21 m22];
    
    c11 = dot(prop.m_b*d_s*rho,tau*d_varphi); %%because w=0
    c12 = dot(prop.m_b*d_s*rho,tau*d_theta)+d_varphi*((dot(prop.m_b*prop.k_hat ,cross(rho,tau))-prop.J_b/prop.R)*dd_s+dot(prop.m_b*prop.k_hat ,cross(rho,kappa))*d_s^2); 
    c21 = -dot(prop.m_b*d_s*rho,tau*d_theta); 
    c22 = (prop.m_b+prop.J_b/prop.R^2)*d_s*dd_s*d_varphi; 
    C = [c11 c12; c21 c22];
    g1 = dot(prop.m_b*prop.grav ,d_Pi*rho); 
    g2 = dot(prop.m_b*prop.grav ,Pi*tau*d_s); 
    G = [g1;g2];
    
elseif prop.pick_MCG == 2 %nominal case I THINK IS THE ONE I NEED.
    m11 = prop.m_b*norm(rho)^2 + prop.J_f + prop.J_b; 
    m12 = (dot(prop.m_b*prop.k_hat ,cross(rho,tau)) + prop.J_b*p)*d_s; 
    m21 = m12; 
    m22 = (prop.m_b + prop.J_b*p^2)*d_s^2; 
    M = [m11 m12; m21 m22];
    
    c11 = dot(prop.m_b*d_s*rho,tau*d_varphi); 
    c12 = dot(prop.m_b*d_s*rho,tau*d_theta)+d_varphi*((dot(prop.m_b*prop.k_hat ,cross(rho,tau))+prop.J_b*p)*dd_s + dot(prop.m_b*prop.k_hat ,cross(rho,kappa))*d_s^2); 
    c21 = -dot(prop.m_b*d_s*rho,tau*d_theta); 
    c22 = (prop.m_b+prop.J_b*p^2)*d_s*dd_s*d_varphi; 
    C = [c11 c12; c21 c22];
    
    g1 = dot(prop.m_b*prop.grav ,d_Pi*rho); 
    g2 = dot(prop.m_b*prop.grav ,Pi*tau*d_s); 
    G = [g1;g2];
    
end

