%% Define Spline function for phi = f(varphi) 
N = 100; a_phi = linspace(0,2*pi,N); 
g=zeros(1,N); 
for i = 1:N 
phi = a_phi(i); 
delta = prop.a-prop.b*cos(2*phi); 
d_delta = 2*prop.b*sin(2*phi); 
alpha = atan((delta*sin(phi)-d_delta*cos(phi))/(delta*cos(phi)+d_delta*sin(phi))); 
if phi > 0.5*pi && phi < 1.5*pi 
    alpha = alpha+pi; 
elseif phi >= 1.5*pi 
    alpha = alpha+2*pi; 
end 
g(i) = atan2(delta*sin(phi)+prop.R*sin(alpha),delta*cos(phi)+prop.R*cos(alpha)); 
end 
g = mod(g,2*pi); 
g = unwrap(g*2)/2; 
prop.phi_app = spline(g,a_phi);
